source: xsoft/graphweb/firefox.xml@ ac105103

10.0 10.1 11.0 11.1 11.2 8.1 8.2 8.3 8.4 9.0 9.1 basic bdubbs/svn elogind lazarus perl-modules qt5new trunk upgradedb xry111/intltool xry111/soup3 xry111/test-20220226
Last change on this file since ac105103 was ac105103, checked in by Ken Moffat <ken@…>, 5 years ago

Firefox requires both gtk3 and gtk2, gtk2 had slipped out. Thanks to Stephen Berman for querying this. Also change the second set of 1st May changelog entries to 2nd May.

git-svn-id: svn://svn.linuxfromscratch.org/BLFS/trunk/BOOK@18685 af4574ff-66df-0310-9fd7-8a98e5e911e0

  • Property mode set to 100644
File size: 15.1 KB
Line 
1<?xml version="1.0" encoding="ISO-8859-1"?>
2<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
3 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
4 <!ENTITY % general-entities SYSTEM "../../general.ent">
5 %general-entities;
6
7 <!ENTITY firefox-download-http "&mozilla-http;/firefox/releases/&firefox-version;/source/firefox-&firefox-version;.source.tar.xz">
8 <!ENTITY firefox-download-ftp " ">
9 <!ENTITY firefox-md5sum "73175f850d4ff6068c6af674df20477c">
10 <!ENTITY firefox-size "204 MB">
11 <!ENTITY firefox-buildsize "4.8 GB (95 MB installed)">
12 <!ENTITY firefox-time "16 SBU (with parallelism=4)">
13]>
14
15<sect1 id="firefox" xreflabel="Firefox-&firefox-version;">
16 <?dbhtml filename="firefox.html" ?>
17
18 <sect1info>
19 <othername>$LastChangedBy$</othername>
20 <date>$Date$</date>
21 </sect1info>
22
23 <title>Firefox-&firefox-version;</title>
24
25 <indexterm zone="firefox">
26 <primary sortas="a-Firefox">Firefox</primary>
27 </indexterm>
28
29 <sect2 role="package">
30 <title>Introduction to Firefox</title>
31
32 <para>
33 <application>Firefox</application> is a stand-alone browser based on the
34 <application>Mozilla</application> codebase.
35 </para>
36
37 &lfs80_checked;
38
39 <bridgehead renderas="sect3">Package Information</bridgehead>
40 <itemizedlist spacing="compact">
41 <listitem>
42 <para>
43 Download (HTTP): <ulink url="&firefox-download-http;"/>
44 </para>
45 </listitem>
46 <listitem>
47 <para>
48 Download (FTP): <ulink url="&firefox-download-ftp;"/>
49 </para>
50 </listitem>
51 <listitem>
52 <para>
53 Download MD5 sum: &firefox-md5sum;
54 </para>
55 </listitem>
56 <listitem>
57 <para>
58 Download size: &firefox-size;
59 </para>
60 </listitem>
61 <listitem>
62 <para>
63 Estimated disk space required: &firefox-buildsize;
64 </para>
65 </listitem>
66 <listitem>
67 <para>
68 Estimated build time: &firefox-time;
69 </para>
70 </listitem>
71 </itemizedlist>
72
73 <bridgehead renderas="sect3">Additional Downloads</bridgehead>
74 <itemizedlist spacing="compact">
75 <listitem>
76 <para>
77 Optional patch to allow system versions of <xref linkend="graphite2"/>
78 and <xref linkend="harfbuzz"/> - this should be regarded as experimental
79 <ulink url="&patch-root;/firefox-&firefox-version;-system_graphite2_harfbuzz-1.patch"/>
80 </para>
81 </listitem>
82 </itemizedlist>
83
84 <note>
85 <para>
86 The tarball <emphasis>firefox-&firefox-version;.source.tar.xz</emphasis>
87 will untar to <emphasis>firefox-&firefox-version;</emphasis> directory.
88 It will also reset the permissions of the current directory to 0755 if you
89 have permisison to do that. If you do this in a directory where
90 the sticky bit is set, such
91 as <filename class="directory">/tmp</filename> it will end with error
92 messages:
93 </para>
94
95<literallayout>tar: .: Cannot utime: Operation not permitted
96tar: .: Cannot change mode to rwxr-xr-t: Operation not permitted
97tar: Exiting with failure status due to previous errors
98</literallayout>
99
100 <para>
101 This does finish with non-zero status, but it does
102 <emphasis>NOT</emphasis> mean there is a real problem.
103 Do not untar as the <systemitem class="username">root</systemitem> user
104 in a directory where the sticky bit is set - that will unset it.
105 </para>
106 </note>
107
108 <bridgehead renderas="sect3">Firefox Dependencies</bridgehead>
109
110 <bridgehead renderas="sect4">Required</bridgehead>
111 <para role="required">
112 <xref linkend="autoconf213"/>,
113 <xref linkend="cargo"/>,
114 both <xref linkend="gtk3"/> and
115 <xref linkend="gtk2"/> (you can omit gtk3 if you change the mozconfig where indicated),
116 <xref linkend="nss"/>,
117 <xref linkend="pulseaudio"/>,
118 (or
119 <xref linkend="alsa-lib"/> which is now deprecated by mozilla, if you
120 edit the mozconfig),
121 <xref linkend="unzip"/>,
122 <xref linkend="yasm"/>, and
123 <xref linkend="zip"/>
124 </para>
125
126 <bridgehead renderas="sect4">Recommended</bridgehead>
127 <para role="recommended">
128 <xref linkend="icu"/>,
129 <xref linkend="libevent"/>,
130 <xref linkend="libvpx"/>, and
131 <xref linkend="sqlite"/>
132 </para>
133
134 <note>
135 <para>
136 If you don't install recommended dependencies, then internal copies of
137 those packages will be used. They might be tested to work, but they can
138 be out of date or contain security holes.
139 </para>
140 </note>
141
142 <note>
143 <para>
144 With <application>Firefox-31.0</application> and later versions, you
145 must have installed <application>Openssl</application> before
146 <application>Python 2</application> or the build system will quickly
147 fail with output including "ImportError: cannot import name
148 HTTPSHandler". If you are in any doubt about this (e.g. upgrading from
149 an older version of Firefox), check if
150 <filename>/usr/lib/python&python2-majorver;/lib-dynload/_ssl.so</filename>
151 exists. If it does not, reinstall <xref linkend="python2"/> (after
152 installing <xref linkend="openssl"/>). The latest version of any
153 <emphasis>currently maintained</emphasis> version of Openssl should be
154 satisfactory if already installed.
155 </para>
156 </note>
157
158 <bridgehead renderas="sect4">Optional</bridgehead>
159 <para role="optional">
160 <xref linkend="curl"/>,
161 <xref linkend="dbus-glib"/>,
162 <xref linkend="doxygen"/>,
163 <xref linkend="GConf"/>,
164 <xref linkend="ffmpeg"/> (runtime),
165 <xref linkend="libwebp"/>,
166 <xref linkend="openjdk"/>,
167 <xref linkend="startup-notification"/>,
168 <xref linkend="valgrind"/>,
169 <xref linkend="wget"/>,
170 <xref linkend="wireless_tools"/>,
171 <ulink url="https://hunspell.github.io/">Hunspell</ulink>,
172 <phrase revision="sysv"><ulink url="http://sourceforge.net/projects/liboauth/files/">liboauth</ulink></phrase>
173 <phrase revision="systemd"><xref linkend="liboauth"/></phrase>,
174 <ulink url="https://github.com/libproxy/libproxy">libproxy</ulink>,
175 and (with the patch)
176 <xref linkend="graphite2"/> and
177 <xref linkend="harfbuzz"/>
178 </para>
179
180 <para condition="html" role="usernotes">
181 User Notes: <ulink url="&blfs-wiki;/firefox"/>
182 </para>
183 </sect2>
184
185 <sect2 role="installation">
186 <title>Installation of Firefox</title>
187
188 <para>
189 The configuration of <application>Firefox</application> is accomplished
190 by creating a <filename>mozconfig</filename> file containing the desired
191 configuration options. A default <filename>mozconfig</filename> is
192 created below. To see the entire list of available configuration options
193 (and an abbreviated description of each one), issue <command>./configure
194 --help</command>. You may also wish to review the entire file and
195 uncomment any other desired options. Create the file by issuing the
196 following command:
197 </para>
198
199<screen><userinput>cat &gt; mozconfig &lt;&lt; "EOF"
200<literal># If you have a multicore machine, all cores will be used by default.
201# If desired, you can reduce the number of cores used, e.g. to 1, by
202# uncommenting the next line and setting a valid number of CPU cores.
203#mk_add_options MOZ_MAKE_FLAGS="-j1"
204
205# If you have installed dbus-glib, comment out this line:
206ac_add_options --disable-dbus
207
208# If you have installed dbus-glib, and you have installed (or will install)
209# wireless-tools, and you wish to use geolocation web services, comment out
210# this line
211ac_add_options --disable-necko-wifi
212
213# Uncomment this option if you wish to build with gtk+-2
214#ac_add_options --enable-default-toolkit=cairo-gtk2
215
216# Uncomment these lines if you have installed optional dependencies:
217#ac_add_options --enable-system-hunspell
218#ac_add_options --enable-startup-notification
219
220# Uncomment the following option if you have not installed PulseAudio
221#ac_add_options --disable-pulseaudio
222# and uncomment this if you installed alsa-lib instead of PulseAudio
223#ac_add_options --enable-alsa
224
225# If you have installed GConf, comment out this line
226ac_add_options --disable-gconf
227
228# Comment out following options if you have not installed
229# recommended dependencies:
230ac_add_options --enable-system-sqlite
231ac_add_options --with-system-libevent
232ac_add_options --with-system-libvpx
233ac_add_options --with-system-nspr
234ac_add_options --with-system-nss
235ac_add_options --with-system-icu
236
237# If you are going to apply the patch for system graphite
238# and system harfbuzz, uncomment these lines:
239#ac_add_options --with-system-graphite2
240#ac_add_options --with-system-harfbuzz
241
242# Stripping is now enabled by default.
243# Uncomment these lines if you need to run a debugger:
244#ac_add_options --disable-strip
245#ac_add_options --disable-install-strip
246
247# The BLFS editors recommend not changing anything below this line:
248ac_add_options --prefix=/usr
249ac_add_options --enable-application=browser
250
251ac_add_options --disable-crashreporter
252ac_add_options --disable-updater
253ac_add_options --disable-tests
254
255ac_add_options --enable-optimize
256
257ac_add_options --enable-gio
258ac_add_options --enable-official-branding
259ac_add_options --enable-safe-browsing
260ac_add_options --enable-url-classifier
261
262# From firefox-40, using system cairo causes firefox to crash
263# frequently when it is doing background rendering in a tab.
264#ac_add_options --enable-system-cairo
265ac_add_options --enable-system-ffi
266ac_add_options --enable-system-pixman
267
268ac_add_options --with-pthreads
269
270ac_add_options --with-system-bz2
271ac_add_options --with-system-jpeg
272ac_add_options --with-system-png
273ac_add_options --with-system-zlib
274
275mk_add_options MOZ_OBJDIR=@TOPSRCDIR@/firefox-build-dir</literal>
276EOF</userinput></screen>
277
278 <para>
279 Compile <application>Firefox</application> by issuing the following
280 commands:
281 </para>
282
283 <para>
284 If you have installed system versions of graphite2 and harfbuzz and wish
285 firefox to use those instead of its shipped versions, apply the patch and
286 uncomment the appropriate entries in the <filename>mozconfig</filename>
287 file. This also ensures that the system versions linked by
288 <filename>libmozgtk.so</filename> match those used in
289 <filename>libxul.so</filename>:
290 </para>
291
292<screen><userinput>patch -Np1 -i ../firefox-&firefox-version;-system_graphite2_harfbuzz-1.patch</userinput></screen>
293
294 <para>
295 If you have installed version 2.1.8 or newer of libevent, fix a file:
296 </para>
297
298<screen><userinput>sed -e s/_EVENT_SIZEOF/EVENT__SIZEOF/ \
299 -i ipc/chromium/src/base/message_pump_libevent.cc</userinput></screen>
300
301 <note><para>
302 If you are compiling <application>Firefox</application> in chroot, make
303 sure you have <envar>$SHELL</envar> environment variable set or prepend
304 <envar>SHELL=/bin/sh</envar>.
305 </para></note>
306
307<screen><userinput>make -f client.mk</userinput></screen>
308
309 <para>
310 This package does not come with a test suite.
311 </para>
312
313 <para>
314 Now, as the <systemitem class="username">root</systemitem> user:
315 </para>
316
317<screen role="root"><userinput>make -f client.mk install INSTALL_SDK= &amp;&amp;
318chown -R 0:0 /usr/lib/firefox-&firefox-version; &amp;&amp;
319
320mkdir -pv /usr/lib/mozilla/plugins &amp;&amp;
321ln -sfv ../../mozilla/plugins /usr/lib/firefox-&firefox-version;/browser</userinput></screen>
322<!--
323 <para>
324 Set environment variables back to their values:
325 </para>
326
327<screen><userinput>export CFLAGS=$CFLAGS_HOLD &amp;&amp;
328export CXXFLAGS=$CXXFLAGS_HOLD &amp;&amp;
329unset CFLAGS_HOLD CXXFLAGS_HOLD</userinput></screen>
330-->
331
332 </sect2>
333
334 <sect2 role="commands">
335 <title>Command Explanations</title>
336
337 <para>
338 <command>make -f client.mk ...</command>: Mozilla products are packaged to
339 allow the use of a configuration file which can be used to pass the
340 configuration settings to the <command>configure</command> command.
341 <command>make</command> uses the <filename>client.mk</filename> file to
342 get initial configuration and setup parameters.
343 </para>
344
345 <para>
346 <command>mkdir -p /usr/lib/mozilla/plugins</command>: This checks
347 that <filename class="directory">/usr/lib/mozilla/plugins</filename>
348 exists.
349 </para>
350
351 <para>
352 <command>ln -sv ... /usr/lib/firefox-&firefox-version;/browser</command>:
353 This command creates a symbolic link to <filename
354 class="directory">/usr/lib/mozilla/plugins</filename>. It's not really
355 needed, as <application>Firefox</application> checks <filename
356 class="directory">/usr/lib/mozilla/plugins</filename> by default, but the
357 symbolic link is made to keep all the plugins installed in one folder.
358 </para>
359
360 </sect2>
361
362 <sect2 role="configuration">
363 <title>Configuring Firefox</title>
364
365 <para>
366 If you use a desktop environment like <application>Gnome</application> or
367 <application>KDE</application> you may like to create a
368 <filename>firefox.desktop</filename> file so that
369 <application>Firefox</application> appears in the panel's menus. If you
370 didn't enable startup-notification in your mozconfig change the
371 StartupNotify line to false. As the
372 <systemitem class="username">root</systemitem> user:
373 </para>
374
375<screen role="root"><userinput>mkdir -pv /usr/share/applications &amp;&amp;
376mkdir -pv /usr/share/pixmaps &amp;&amp;
377
378cat &gt; /usr/share/applications/firefox.desktop &lt;&lt; "EOF" &amp;&amp;
379<literal>[Desktop Entry]
380Encoding=UTF-8
381Name=Firefox Web Browser
382Comment=Browse the World Wide Web
383GenericName=Web Browser
384Exec=firefox %u
385Terminal=false
386Type=Application
387Icon=firefox
388Categories=GNOME;GTK;Network;WebBrowser;
389MimeType=text/html;text/xml;application/xhtml+xml;application/vnd.mozilla.xul+xml;text/mml;x-scheme-handler/http;x-scheme-handler/https;
390StartupNotify=true</literal>
391EOF
392
393ln -sfv /usr/lib/firefox-&firefox-version;/browser/icons/mozicon128.png \
394 /usr/share/pixmaps/firefox.png</userinput></screen>
395
396 </sect2>
397
398 <sect2 role="content">
399 <title>Contents</title>
400
401 <segmentedlist>
402 <segtitle>Installed Programs</segtitle>
403 <segtitle>Installed Libraries</segtitle>
404 <segtitle>Installed Directory</segtitle>
405
406 <seglistitem>
407 <seg>
408 firefox
409 </seg>
410 <seg>
411 Numerous libraries, browser components, plugins, extensions, and
412 helper modules installed in /usr/lib/firefox-&firefox-version;
413 </seg>
414 <seg>
415 /usr/lib/firefox-&firefox-version; and /usr/lib/mozilla
416 </seg>
417 </seglistitem>
418 </segmentedlist>
419
420 <variablelist>
421 <bridgehead renderas="sect3">Short Descriptions</bridgehead>
422 <?dbfo list-presentation="list"?>
423 <?dbhtml list-presentation="table"?>
424
425 <varlistentry id="firefox-prog">
426 <term><command>firefox</command></term>
427 <listitem>
428 <para>
429 is a <application>GTK+-3</application> internet browser that uses
430 the Mozilla Gecko rendering engine.
431 </para>
432 <indexterm zone="firefox firefox-prog">
433 <primary sortas="b-firefox">firefox</primary>
434 </indexterm>
435 </listitem>
436 </varlistentry>
437
438 </variablelist>
439
440 </sect2>
441
442</sect1>
Note: See TracBrowser for help on using the repository browser.